package rabinizer.exec;

import java.util.*;
import rabinizer.formulas.*;

/**
 * 
 * @author Andreas Gaiser & Ruslan Ledesma-Garza
 * 
 */
public class BijectionBooleanAtomBddVar {
	
	Map<Formula, Integer> atomToId = new HashMap<Formula, Integer>();
	Map<Integer, Formula> idToAtom = new HashMap<Integer, Formula>();
	
    /**
	 * The corresponding to atom. If atom is not stored, return an identifier that is fresh for this instance.
	 * 
	 * @param t
	 * @return
	 */
	public int id(Formula atom) {
		Integer id = atomToId.get(atom);
		if (id == null) {
			int nextId = idToAtom.size();
			idToAtom.put(nextId, atom);
			atomToId.put(atom, nextId);
			return nextId;
		} else
			return id.intValue();
	}
	
	public Formula atom(int id) {
		return idToAtom.get(id);
	}

	public int size() {
		return idToAtom.size();
	}
	
	public String toString() {
		return idToAtom.toString();
	}
}
