package tests;

import static org.junit.Assert.*;

import java.io.StringReader;
import java.util.Arrays;
import java.util.Collection;

import org.junit.Test;

import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import rabinizer.formulas.Formula;
import rabinizer.parser.LTLParser;

@RunWith(value = Parameterized.class)
public class toNNF {

	private String input;
	private String nnf;	
	private boolean expected;
	
	public toNNF(String input, String nnf, boolean expected) {
		this.input = input;
		this.nnf = nnf;
		this.expected = expected;
	}

    @Parameters
	public static Collection<Object[]> data() {
        Object[][] data = new Object[][] { 
            { "! (a & b)", "! a | ! b", true },
        };
        return Arrays.asList(data);
    }

	@Test
	public void pushTest() {
		System.out.println(this.getClass().getCanonicalName());
		
		LTLParser parser = new LTLParser(new StringReader(input));
		Formula inf = null;
		try { inf = parser.parse(); }
		catch (Exception e) { assertTrue(false); }
		
		parser.ReInit(new StringReader(nnf));
		Formula exf = null;
		try { exf = parser.parsePreviousAtoms(); }
		catch (Exception e) { assertTrue(false); }
		
		System.out.println("input    : "+inf);
		System.out.println("actual   : "+inf.toNNF());
		System.out.println("nnf      : "+exf);
		System.out.println("expected : "+expected);
		
		assertTrue(exf.equals(inf.toNNF()) == expected);
	}
}
